<?php
namespace Zeedhi\DevOps\Model\Projectmanagement\Repositories;

use Doctrine\ORM\EntityRepository;
use Zeedhi\DevOps\Model\Util\LogicalDeleted;
use Zeedhi\DevOps\Util\Utilities;

class ClassificationBudgetItem extends EntityRepository {


    public function classificationBudgetItem($classificationId,$conditionsSQL,$limit, $offset) {
        $query = <<<SQL
        SELECT * FROM (
			SELECT CLB.ID, BUI.ID AS BUDGET_ITEM_ID,BUI.ORGANIZATION_ID ,RES.NAME AS CREATED_BY ,BUI.CREATED_AT ,BUI.UPDATED_BY ,BUI.UPDATED_AT ,BUI.NAME ,
			       TO_CHAR(BUI.VALUE,'999G999G999G990D00', 'NLS_NUMERIC_CHARACTERS = '',.''') AS VALUE_ITEM,
			       BUI.UNIT_MEASURE,BUI.STATUS
			  FROM BUDGET_ITEM BUI
			  JOIN RESOURCE_T RES ON (BUI.UPDATED_BY = RES.ID)
			  JOIN CLASSIFICATION_BUDGET_ITEM CLB ON (CLB.BUDGET_ITEM = BUI.ID AND CLB.CLASSIFICATION = :classificationId)
			 WHERE BUI.STATUS <> :statusDeleted)
			   WHERE 1 = 1
			    $conditionsSQL
SQL;
        $params = array(
            'classificationId' => $classificationId,
            'statusDeleted' => LogicalDeleted::STATUS_LOGICAL_DELETED,
        );

        $query = Utilities::getPaginatedQuery($query, $limit, $offset);
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

}